<template>
  <svg class="rui-icon" :class="cssClasses" viewBox="0 0 24 24">
    <title v-if="title">{{ title }}</title>
    <use :xlink:href="href" />
  </svg>
</template>

<script>
export const sizes = ['3', '4', '10']

/**
 * Displays icons.
 *
 * The color is the CSS `currentColor` value, and size is in `em`.
 *
 * @preset Default { "props": { "name": "rui:floppy-disk" } }
 * @propsGroup Display  [size]
 * @propsGroup Behavior [spin]
 * @propsGroup Content  [name, title]
 */
export default {
  name: 'RuiIcon',
  props: {
    /** Icon name. Specify custom pack with a prefix like: `pack:icon` */
    name: { required: true, type: String },
    /**
     * Custom icon size. Will be in `em`
     *
     * @values 3, 4, 10
     */
    size: { required: false, type: [String, Number], default: null, validator: v => sizes.includes(v.toString()) },
    /** Title to show when hovering the icon */
    title: { required: false, type: String, default: null },
    /** Make the icon spin */
    spin: { required: false, type: Boolean, default: false },
  },
  computed: {
    href () {
      if (!this.name.includes(':')) return this.referenceString('default', this.name)
      const chunks = this.name.split(':')
      const pack = chunks.shift()
      const name = chunks.join(':')

      return this.referenceString(pack, name)
    },
    cssClasses () {
      const classes = []
      if (this.spin) classes.push('rui-icon--spin')
      if (this.size) classes.push(`rui-icon--${this.size}x`)

      return classes.join(' ')
    },
  },
  methods: {
    referenceString (pack, icon) { return `${this.$_ruiIconsFiles[pack]}#icon-${icon}` },
  },
}
</script>
